SuperStrict


Type TScreen
	Field background:TImage
'	Field fog:TImage
	Field sleigh:TSleigh
	Method New()
		background = LoadImage("media/background.png")
'		fog = LoadImage("media/fog.png")
		sleigh = New TSleigh
		Graphics GRWIDTH,GRHEIGHT,0
		SetBlend ALPHABLEND
		SetColor 255,255,255
		TMessage.Create("Geschenke abwerfen mit Space!",255,255,0,GRWIDTH/2,GRHEIGHT/2)
		TMessage.Create("Viel Spass!",255,255,0,GRWIDTH/2+50,GRHEIGHT/2+20)
	EndMethod
	Method update(gamestopped:Int=0)
		If Not gamestopped Then sleigh.update()
		If Not gamestopped Then TPresent.updateAll()
		THouse.updateAll()
		TMessage.updateAll()
		TArgue.updateAll()
		TSnowflake.updateAll()
		If Not gamestopped Then TPlayerState.update()
		If Not gamestopped Then scroll()
		draw()
	EndMethod
	Method scroll()
		TPresent.scrollAll()
		THouse.scrollAll()
		TMessage.scrollAll()
		TArgue.scrollAll()
	EndMethod
	Method draw()
		Cls
		DrawImageRect background,0,0,GRWIDTH,GRHEIGHT
		TPlayerState.draw()
		TPresent.drawAll()
		THouse.drawAll()
		sleigh.draw()
		TMessage.drawAll()
		TArgue.drawAll()
		TSnowflake.drawAll()
rem
		Local a:Float = GetAlpha()
		For Local i:Int = 0 To 400
			SetAlpha 0.25-i/1600.0
			DrawImageRect fog,i,0,1,GRHEIGHT
			DrawImageRect fog,GRWIDTH-i,0,1,GRHEIGHT
		Next
		SetAlpha a
endrem
		Flip
	EndMethod
	Method stopGame()
		TMessage.Create("Game over",255,255,0,400,400)
		TMessage.Create("Deine Punkte: "+TPlayerstate.score,255,255,0,400,420)
		Repeat
			tim.wait()
			update(1)
		Until TMessage.messages.count() = 0
		End
	EndMethod
EndType


Type TSleigh
	Field image:TImage
	Field x:Int
	Field y:Int
	Field throw_x:Int
	Field throw_y:Int
	Method New()
		image = LoadImage("media/sleigh.png")
		x = 300
		y = 0
		throw_x = 130
		throw_y = 120
	EndMethod
	Method update()
		If KeyHit(KEY_SPACE) Then TPresent.Create(x+throw_x,y+throw_y)
	EndMethod
	Method draw()
		DrawImage image,x,y
	EndMethod
EndType


Type THouse
	Global houses:TList = New TList
	Const IMAGECOUNT:Int = 4
	Global images:TImage[] = New TImage[IMAGECOUNT]
	Field imagenr:Int
	Field x:Int
	Field y:Int
	Field chimneyX:Int
	Field chimneyY:Int
	Field chimneywidth:Int
	Field badkids:Int
	Function init()
		For Local i:Int = 1 To IMAGECOUNT
			images[i-1] = LoadImage("media/house"+i+".png")
		Next
	EndFunction
	Function updateAll()
		If houses.count() = 0 Then
			New THouse
		ElseIf houses.count() < 5 And THouse(houses.last()).x < 500 Then
			New THouse
		EndIf
		For Local i:THouse = EachIn houses
			i.update()
		Next
	EndFunction
	Function scrollAll()
		For Local i:THouse = EachIn houses
			i.scroll()
		Next
	EndFunction
	Function drawAll()
		For Local i:THouse = EachIn houses
			i.draw()
		Next
	EndFunction
	Method New()
		imagenr = Rand(0,IMAGECOUNT-1)
		x = 1000
		y = Rand(250,420)
		chimneyX = 195
		chimneyY = 16
		chimneywidth = 83
		badkids = (Rand(1,5) = 1)
		If badkids = 1 Then
			For Local i:Int = 1 To 3
				TArgue.Create(Self)
			Next
		EndIf
		houses.addlast(Self)
	EndMethod
	Method update()
		If x < -300 Then houses.remove(Self)
	EndMethod
	Method scroll()
		x :- SCROLLSPEED
	EndMethod
	Method draw()
		DrawImage images[imagenr],x,y
	EndMethod
EndType


Type TPresent
	Global presents:TList = New TList
	Const IMAGECOUNT:Int = 3
	Global images:TImage[] = New TImage[IMAGECOUNT]
	Field imagenr:Int
	Field x:Int
	Field y:Int
	Field xspeed:Float
	Field yspeed:Float
	Function init()
		For Local i:Int = 1 To IMAGECOUNT
			images[i-1] = LoadImage("media/present"+i+".png")
		Next
	EndFunction
	Function Create:TPresent(xpos:Int,ypos:Int)
		Local p:TPresent = New TPresent
		p.imagenr = Rand(0,IMAGECOUNT-1)
		p.x = xpos
		p.y = ypos
		p.xspeed = SCROLLSPEED
		p.yspeed = 0
		presents.addlast(P)
	EndFunction
	Function updateAll()
		For Local i:TPresent = EachIn presents
			i.update()
		Next
	EndFunction
	Function scrollAll()
		For Local i:TPresent = EachIn presents
			i.scroll()
		Next
	EndFunction
	Function drawAll()
		For Local i:TPresent = EachIn presents
			i.draw()
		Next
	EndFunction
	Method update()
		yspeed :+ 0.1962
		x :+ xspeed
		y :+ yspeed
		If y > GRHEIGHT Then
			remove(0)
			TPlayerState.present_fail()
		EndIf
		For Local i:THouse = EachIn THouse.houses
			If x > i.x + i.chimneyX - 25 And x < i.x + i.chimneyX + i.chimneywidth - 25 And y > i.y + i.chimneyY - 10 And y < i.y + i.chimneyY + 10 Then
				If i.badkids = 0 Then
					remove(1)
					TPlayerState.present_hit()
				ElseIf i.badkids = 1 Then
					remove(2)
					TPlayerState.present_badhit()
				EndIf
			EndIf
		Next
	EndMethod
	Method scroll()
		x :- SCROLLSPEED
	EndMethod
	Method draw()
		DrawImage images[imagenr],x,y
	EndMethod
	Method remove(hit:Int) '0 für daneben, 1 für Treffer, 2 für Treffer in ein Haus mit bösen Kindern
		If hit = 0 Then
			TMessage.Create("-"+TPlayerState.TIMEFORFAIL+"s",255,0,0,x,y)
		ElseIf hit = 1 Then
			TMessage.Create("+"+TPlayerstate.TIMEFORHIT+"s",0,255,0,x,y)
'			TMessage.Create("+"+TPlayerstate.SCOREFORHIT+"P",0,255,0,x,y+20)
		ElseIf hit = 2 Then
			TMessage.Create("-"+TPlayerstate.TIMEFORBADHIT+"s",255,0,0,x,y)
		EndIf
		presents.remove(Self)
	EndMethod
EndType


Type TMessage
	Global messages:TList = New TList
	Field text:String
	Field red:Int
	Field green:Int
	Field blue:Int
	Field alpha:Float
	Field x:Int
	Field y:Int
	Function Create:TMessage(t:String,r:Int,g:Int,b:Int,x:Int,y:Int)
		Local M:TMessage = New TMessage
		M.text = t
		M.red = r
		M.green = g
		M.blue = b
		M.alpha = 2
		M.x = x
		M.y = y
		messages.addlast(M)
	EndFunction
	Function updateAll()
		For Local i:TMessage = EachIn messages
			i.update()
		Next
	EndFunction
	Function scrollAll()
		For Local i:TMessage = EachIn messages
			i.scroll()
		Next
	EndFunction
	Function drawAll()
		For Local i:TMessage = EachIn messages
			i.draw()
		Next
	EndFunction
	Method update()
		y :- 1
		If y < -20 Then messages.remove(Self)
		alpha :- 0.01
		If alpha < 0 Then messages.remove(Self)
	EndMethod
	Method scroll()
		x :- SCROLLSPEED / 2
	EndMethod
	Method draw()
		Local r:Int,g:Int,b:Int
		GetColor(r,g,b)
		Local a:Float = GetAlpha()
		SetColor red,green,blue
		If alpha > 1 Then SetAlpha 1 Else SetAlpha alpha
		DrawText text,x,y
		SetAlpha a
		SetColor r,g,b
	EndMethod
EndType


Type TArgue
	Global argues:TList = New TList
	Const IMAGECOUNT:Int = 3
	Global images:TImage[] = New TImage[IMAGECOUNT]
	Field imagenr:Int
	Field house:THouse
	Field x:Int
	Field y:Int
	Field rotation:Int
	Field alpha:Float
	Function init()
		For Local i:Int = 1 To IMAGECOUNT
			images[i-1] = LoadImage("media/argue"+i+".png")
			MidHandleImage images[i-1]
		Next
	EndFunction
	Function Create:TArgue(h:THouse)
		Local A:TArgue = New TArgue
		A.imagenr = Rand(0,IMAGECOUNT-1)
		A.house = h
		A.x = Rand(h.x+50,h.x+300)
		A.y = Rand(h.y+50,h.y+300)
		A.rotation = 0
		A.alpha = Rnd(0,1)
		argues.addlast(A)
	EndFunction
	Function updateAll()
		For Local i:TArgue = EachIn argues
			i.update()
		Next
	EndFunction
	Function scrollAll()
		For Local i:TArgue = EachIn argues
			i.scroll()
		Next
	EndFunction
	Function drawAll()
		For Local i:TArgue = EachIn argues
			i.draw()
		Next
	EndFunction
	Method update()
		y :- 3
		rotation :+ 5
		If rotation >= 360 Then rotation = 0
		alpha :- 0.01
		If alpha < 0 Then
			alpha = 1
			x = Rand(house.x+50,house.x+300)
			y = Rand(house.y+50,house.y+300)
		EndIf
	EndMethod
	Method scroll()
		x :- SCROLLSPEED
	EndMethod
	Method draw()
		Local rot:Int = GetRotation()
		Local a:Float = GetAlpha()
		SetRotation rotation
		SetAlpha alpha
		DrawImage images[imagenr],x,y
		SetAlpha a
		SetRotation rot
	EndMethod
EndType


Type TSnowflake
	Global snowflakes:TList = New TList
	Field image:TImage
	Field x:float
	Field y:float
	field siny:int
	Field rotation:Int
	Function init()
		For Local i:Int = 1 To 50
			Create(Null,Rand(0,GRHEIGHT))
		Next
	EndFunction
	Function Create(x:Int=Null,y:Int=Null)
		Local size:Int = rand(10,25)
		Local F:TSnowflake = New TSnowflake
		F.image = CreateImage(size,size)
		F.image.handle_x = size/2			'midhandleimage macht das bild hässlich wenn es eine ungerade Seitenlänge hat, hat glaubich irgendwas damit zu tun dass handle_x/y als Floats deklariert sind
		F.image.handle_y = size/2			'also nutze ich das hier
		If x = Null Then F.x = Rand(0,GRWIDTH) Else F.x = x
		If y = Null Then F.y = 0 Else F.y = y
		F.siny = rand(0,360)
		F.rotation = 0
		F.makeflake(size)
		snowflakes.addlast(F)
	EndFunction
	Function updateAll()
		For Local i:TSnowflake = EachIn snowflakes
			i.update()
		Next
		If snowflakes.count() < 50 Then TSnowflake.Create()
	EndFunction
	Function drawAll()
		For Local i:TSnowflake = EachIn snowflakes
			i.draw()
		Next
	EndFunction
	Method makeflake(size:Int)	'na dann mal mal eine Schneeflocke... bis die funktion endlich mal lief ey...
		Local middle:Int = size/2
		Local map:TPixmap = LockImage(image)
		map.ClearPixels($00000000)
		map.WritePixel(middle,middle,$ff000000)
		
		Local branchcount:Int = rand(5,8)
		For Local i:Int = 1 To branchcount
			For Local n:Int = 1 To size/2-2
				Local angle:Float = i*(360/branchcount)
				Local x:Int = middle+Sin(angle)*n
				Local y:Int = middle+Cos(angle)*n
				map.WritePixel(x,y,$ffffffff)
				If (n Mod 5) = 0 Then
					For Local k:Int = 1 To n/2
						
						Local x1:Int,y1:Int
						local x2:int,y2:int
						
						x1 = x-Cos(angle+30)*k
						y1 = y+Sin(angle+30)*k
						
						x2 = x+Cos(angle-30)*k
						y2 = y-Sin(angle-30)*k
						
						If x1 >= 0 and y1 >= 0 and x1 < size And y1 < size Then map.WritePixel(x1,y1,$ffffffff)
						If x2 >= 0 and y2 >= 0 and x2 < size-1 And y2 < size-1 Then map.WritePixel(x2,y2,$ffffffff)
					Next
				EndIf
			Next
		Next
		
		UnlockImage(image)
	EndMethod
	Method update()
		y :+ 1
		If y > GRHEIGHT + 30 Then remove()
		x :+ (sin(y+siny-1)+sin(y+siny))  'bin überrascht wie gut das aussieht! *_*
		rotation :+ 1
	EndMethod
	Method draw()
		Local rot:Int = GetRotation()
		SetRotation rotation
		DrawImage image,x,y
		SetRotation rot
	EndMethod
	Method remove()
		snowflakes.remove(Self)
	EndMethod
EndType
		




Type TPlayerState
	Const SCOREFORHIT:Int = 100
	Const TIMEFORHIT:Int = 20
	Const TIMEFORFAIL:Int = 10
	Const TIMEFORBADHIT:Int = 30
	
	Global score:Int = 0
	Global time:Float = 80
	Function present_hit()
		score :+ SCOREFORHIT
		time :+ TIMEFORHIT
	EndFunction
	Function present_fail()
		time :- TIMEFORFAIL
		if time < 0 then time = 0
	EndFunction
	Function present_badhit()
		time :- TIMEFORBADHIT
		if time < 0 then time = 0
	EndFunction
	Function update()
		time :- 1/Float(FRAMES)
		If time <= 0 Then screen.stopGame()
	EndFunction
	Function draw()
		DrawText "Punkte: " + score,10,10
		
		Local time2:Int = Ceil(time)
		Local minutes:Int = Int(Floor(time2 / 60.0))
		Local seconds:Int = (time2 Mod 60)
		Local seconds_output:String
		If seconds < 10 Then seconds_output = "0"+seconds Else seconds_output = seconds
		DrawText "Zeit: " + minutes + ":" + seconds_output,10,30
	EndFunction
EndType



Const GRWIDTH:Int = 1000
Const GRHEIGHT:Int = 650
Const FRAMES:Int = 40
Const SCROLLSPEED:Int = 5


SeedRnd MilliSecs()


Global screen:TScreen = New TScreen
TPresent.init()
THouse.init()
TArgue.init()
TSnowflake.init()

Global tim:TTimer = CreateTimer(FRAMES)


Repeat
	tim.wait()
	If KeyDown(KEY_ESCAPE) Then End
	
	screen.update()
Until AppTerminate()








