Rem
	ChristmasWire
EndRem

SuperStrict
If FileType("USEGL") SetGraphicsDriver GLMax2DDriver()

Type TWire
	Global Glibbor:Byte=0
	Global MoveX:Byte=0
	Global WireImg:TImage, ZapfenImg:TImage
	Global MaxGlibAngle:Float=0
	Field X1:Float, Y1:Float, X2:Float, Y2:Float, Angle:Float, Dist:Float
	Field Child:TWire, Parent:TWire
	Field hasZapfen:Byte=Rand(1,20)=1
	Field GlibAngle:Float=0, Dir:Byte
	Method Create:TWire(X1:Float,Y1:Float,X2:Float,Y2:Float)
		Self.X1=X1
		Self.Y1=Y1
		Self.X2=X2
		Self.Y2=Y2
		Self.Angle=GetAngle(X1,Y1,X2,Y2)
		Self.Dist=GetDistance(X1,Y1,X2,Y2)
		If Glibbor
			MaxGlibAngle:+2'Rand(-4,4)
			GlibAngle=MaxGlibAngle
		ElseIf MoveX
			MaxGlibAngle:+.25 
			If MAxGlibAngle>1 MaxGlibAngle=-1
			GlibAngle=MaxGlibAngle
		EndIf
		Return Self
	EndMethod
	Method SetChild(C:TWire)
		Child=C
		C.Parent=Self
	EndMethod
	Method Update()
		If Glibbor
			Const Dist:Float=2
			Local SX:Float, SY:Float
			SX=Cos(GlibAngle)*Dist
			SY=Sin(GlibAngle)*Dist
			X1:+SX
			Y1:+SY
			X2:+SX
			Y2:+SY
			
			For Local C:TCar=EachIn TCar.Cars
				If C.CurrentWire=Self
					C.X:+SX
					C.Y:+SY
				EndIf
			Next
			
			GlibAngle:+4
		ElseIf MoveX
			GlibAngle=GlibAngle Mod 5
			If GlibAngle>1
				GlibAngle=1
				Dir=1-Dir
			ElseIf GlibAngle<-1
				GlibAngle=-1
				Dir=1-Dir
			EndIf
			Select Dir
				Case 0
					GlibAngle:+.05
				Case 1
					GlibAngle:-.05
			EndSelect
			
			Local SX:Float=GlibAngle
			X1:+SX
			X2:+SX
			
			For Local C:TCar=EachIn TCar.Cars
				If C.CurrentWire=Self
					C.X:+SX
				EndIf
			Next
		EndIf
		If Child Child.Update()
		If (Glibbor Or MoveX) And Parent
			PArent.Angle=GetAngle(Parent.X1,Parent.Y1,X1,Y1)
			PArent.Dist=GetDistance(Parent.X1,Parent.Y1,X1,Y1)
		EndIf
	EndMethod
	Method Render()
		'DrawLine X1,Y1,X2,y2
		
		If Child And Not Child.Child
			Local Dist:Float=ScreenWidth
			SetRotation 0
			SetScale Dist,1
			DrawImage WireImg,X1-ScrollX,Y1-ScrollY
			SetColor 0,0,0
			SetAlpha .255
			DrawImage WireImg,X1+4-ScrollX,Y1+8-ScrollY
			SetAlpha 1
			SetColor 255,255,255
		EndIf
		
		If Parent And Not Parent.Parent
			Local Dist:Float=ScreenWidth
			SetRotation 180
			SetScale Dist,-1
			DrawImage WireImg,X1-ScrollX,Y1-ScrollY
			SetColor 0,0,0
			SetAlpha .255
			DrawImage WireImg,X1+4-ScrollX,Y1+8-ScrollY
			SetAlpha 1
			SetColor 255,255,255
		EndIf
		If Parent
			SetRotation Angle+180
			SetScale Dist/WireImg.Width,1
			DrawImage WireImg,X1-ScrollX,Y1-ScrollY
			
			SetColor 0,0,0
			SetAlpha .255
			DrawImage WireImg,X1+4-ScrollX,Y1+8-ScrollY
			SetAlpha 1
			SetColor 255,255,255
			
			If haszapfen
				SetScale .25,1
				SetRotation 0
				DrawImage ZapfenImg,X1-ScrollX,Y1-ScrollY
			EndIf
		EndIf
		If Child Child.Render()
		
	EndMethod
EndType
Type TGameMap
	Global Img:TImage
	Global Background:TImage
	Global StartWire:TWire
	Global RandDel:Int
	Global CurrentLevel:Int=0
	Global MapWidth:Int, MapHeight:Int
	Function Update()
	
	EndFunction

	Function Render()
		If Background 
			Const mul:Float=.75
			SetColor 255,255,255
			DrawRect -scrollx*mul-screenwidth,background.height-scrolly*mul,background.width+screenwidth*2,screenheight
			DrawImage Background, -scrollx*mul,-scrolly*mul
		EndIf
		For Local C:TCloud=EachIn TCloud.Clouds
			C.Render()
		Next
		If StartWire StartWire.Render()
		SetRotation 0
		SetScale 1,1
	EndFunction
	
	Function Load()
		TWire.Glibbor=0
		TWire.MoveX=0
		CurrentLevel:+1
		StartWire=Null
		Img=Null
		TSweet.List.Clear()
		BackGround=Null 
		Img=Null
		Local Img:String="gfx/track"+CurrentLevel
		If Not FileType(Img)
			If Menu("Gewonnen! Sie haben alle Level geschafft.","Neustart","Beenden")
				Reset()
				MainGame()
			Else
				End
			EndIf
		EndIf
		Self.Background=LoadImage(Img+"/bg1.png")
		If BackGround
			SetImageHandle(Self.background,0,0)
		EndIf
		
		Local CreateSweet:Int=100
		Local S:TStream=ReadFile(Img+"/setting.txt")
		CreateSweet=Int(ReadLine(S))
		RandDel=Int(ReadLine(S))
		Select Int(ReadLine(S))
			Case 1
				TWire.Glibbor=1
			Case 2
				TWire.MoveX=1
		EndSelect
		'Schauen obs eine Verbindungsdatei schon gibt
		If FileType(Img+"/data.txt")<>1
			Self.Img=LoadImage(Img+"/track.png")
			SetImageHandle Self.Img,0,0
			Local Colli:Byte[,]=New Byte[Self.Img.Width,Self.Img.Height]
			Const StepTrack:Int=2
			For Local X:Float=0 Until Self.Img.Width Step StepTrack
				For Local y:Float=0 Until Self.Img.Height Step StepTrack
					If ReadPixel(Self.Img.pixmaps[0],X,Y)=0 
						Colli[X,Y]=False
					Else
						Colli[X,Y]=True
					EndIf
				Next
			Next
			'Nun die einzelnen Punkte solange verbinden, bis keine Punkte brig sind
			'den ersten punkt auf der y achse suchen
			Local Dot:Byte[Self.Img.Width, Self.img.height]
			For Local X:Float=0 Until Self.Img.Width Step StepTrack
				For Local y:Float=0 Until Self.Img.Height Step StepTrack
					Dot[X,Y]=Colli[X,Y]
				Next
			Next
			Local LastX:Float, LastY:Float, LastWire:TWire
			For Local Y:Int=0 Until Self.img.height
				If Dot[0,Y]
					LastX=0
					LastY=Y
					Dot[LastX,lastY]=0
				EndIf
			Next
			Local AnyFree:Byte=True
			While AnyFree
				AnyFree=False
				'nun nchsten punkt suchen
				Local MinDist:Float=-1, CurX:Float,CurY:Float
				For Local X:Float=0 Until Self.Img.Width Step StepTrack
					For Local y:Float=0 Until Self.Img.Height Step StepTrack
						If Dot[X,Y]
							'Schauen wie weit
							If GetDistance(X,Y,LastX,LastY)>200 Continue
							If MinDist=-1 Or (GetDistance(X,Y,LastX,LastY)<Abs(MinDist-1))
								CurX=X
								CurY=Y
								MinDist=GetDistance(X,Y,LastX,LastY)
							ElseIf GetDistance(X,Y,LastX,LastY)=MinDist
								'Weg damit
								Dot[X,Y]=0
							EndIf
							AnyFree=True
						EndIf
					Next
				Next
				Local W:TWire=New TWire.Create(LastX,LastY,CurX,CurY)
				If LastWire LastWire.SetChild(W) Else StartWire=W
				LastWire=W
				Dot[CurX,CurY]=0
				LastX=CurX
				LastY=CurY
			Wend
			If LastWire LastWire.Parent.Child=Null
			Local S:TStream=WriteFile(Img+"/data.txt")
			Local W:TWire=StartWire
			While W
				WriteFloat S,W.X1
				WriteFloat S,W.Y1
				WriteFloat S,W.X2
				WriteFloat S,W.Y2
				W=W.CHild
			Wend
			S.Close()
		Else
			Local S:TStream=ReadFile(Img+"/data.txt")
			Local LastWire:TWire
			LastWire=Null
			Repeat
				Local X1:Float, Y1:Float, X2:Float, Y2:Float
				X1=ReadFloat(S)
				Y1=ReadFloat(S)
				X2=ReadFloat(S)
				Y2=ReadFloat(S)
				
				Local W:TWire=New TWire.Create(X1,Y1,X2,Y2)
				If LastWire LastWire.SetChild(W) Else StartWire=W
				LastWire=W
			Until Eof(S)
			If StartWire.Child=Null End 
			If LastWire LastWire.Parent.Child=Null
		EndIf
		
		Local W:TWire=StartWire
		While W
			If W.X2>MapWidth MapWidth=W.X2
			If W.Y2>MapHeight MapHeight=W.Y2
			If Rand(1,CreateSweet)=1 New TSweet.Create(W)
			W=W.Child
		Wend
	EndFunction
EndType

Type TCar
	Global Cars:TList=New TList
	Global CarImg:TImage
	
	Field X:Float, Y:Float
	Field CurrentWire:TWire
	Field Speed:Float
	Method Update()
		Local KRight:Int=KeyR(), KLeft:Int=KeyL()
		If KRight And KLeft
			KLeft=0
		EndIf
		If KRIGHT
			Speed:+.25
		ElseIf KLEFT
			Speed:-.25
		ElseIf Abs(Speed)<.2
			Speed=0
		EndIf
		For Local i:Float=.25 To Abs(Speed) Step .25
			Local T:Float=-.25
			Local S:Float=T*((speed<0)*-1)+T*(speed>0)
			If S<>0
				Local Angle:Float
				Angle=GetAngle(X,Y,CurrentWire.X2,CurrentWire.Y2)+((S>0)*180)
				X:+Cos(Angle)*S
				Y:+Sin(Angle)*S
			EndIf
			
			If GetDistance(X,Y,CurrentWire.X2,CurrentWire.Y2)<1 Or GetDistance(X,Y,CurrentWire.X1,CurrentWire.Y1)<1
				If CurrentWire.Child And S<0
					CurrentWire=CurrentWire.Child
				ElseIf CurrentWire.Parent And S>0
					CurrentWire=CurrentWire.Parent
				EndIf
			EndIf
		Next
		Speed:*.975	
	EndMethod 
	Method SetPosition(W:TWire)
		CurrentWire=W
		X=W.X2
		Y=W.Y2
	EndMethod
	Method New()
		Cars.AddLast(Self)
	EndMethod
	Method KeyL:Int() Abstract
	Method KeyR:Int() Abstract
	Method Render() Abstract
EndType
Type TPlayer Extends TCar
	Global LiveImg:TImage
	Field Dir:Int, Angle:Int, Live:Int=4
	Field Time:Int=1000*60*4
	Method KeyL:Int()
		If KeyDown(KEY_LEFT)
			Dir=1
			Return True
		Else
			Return False
		EndIf	
	EndMethod
	Method KeyR:Int()
		If KeyDown(KEY_Right)
			Dir=0
			Return True
		Else
			Return False
		EndIf	
	EndMethod
	Method Render()
		SetRotation Angle
		SetScale (Dir=1)*-1+(Dir=0)*1,1
		DrawImage CarImg,X-ScrollX,Y-ScrollY
		SetRotation 0
		SetScale 1,1
		For Local i:Int=1 To Live
			DrawImage LiveImg,10+i*18,32
		Next
		If Live<=0
			Live=4
			If Not Menu("Game Over","Neustart","Beenden") End
			Reset()
			MainGame()
		EndIf
		'DrawText "Zeit: "+(Time/1000),10,10
	EndMethod
	Method Update()
		Time:-10
		If CurrentWire
			Local W1:TWire=CurrentWIre
			Local W2:TWire=CurrentWire
			Local i:TWire=CurrentWire
			For Local i:Int=0 To 4
				Local o:TWire=W1
				W1=W1.Parent
				If Not W1 
					W1=o
					Local WW:TWire=CurrentWire
					For Local i2:Int=0 To 4
						WW=WW.Child
					Next
					W1=WW
					W2=WW
					Exit
				EndIf
			Next
			For Local i:Int=0 To 4
				Local o:TWire=W2
				W2=W2.Child
				If Not W2 
					W2=o
					Exit
				EndIf
			Next
			
			Angle=GetAngle(W1.X1,W1.Y1,W2.X1,W2.Y1)+180
			CurrentWire=i
		EndIf
		For Local S:TSweet=EachIn TSweet.List
			If GetDistance(X,Y,S.X,S.Y)<128 And ImagesCollide2(CarImg,X,Y,0,Angle,(Dir=1)*-1+(Dir=0)*1,1, S.Img,S.X,S.Y,0,S.Rot,1,1)
				Live:-1
				For Local i:Int=0 To 20
					New TParticle
				Next
				TSweet.List.Remove(S)
			EndIf
		Next
		Super.Update()
		'Zu Scroll <w
		Local Angle:Float, Dist:Float
		Angle=GetAngle(X-ScreenWidth/2,Y-ScreenHeight/2,ScrollX,ScrollY)
		Dist=GetDistance(X-ScreenWidth/2,Y-ScreenHeight/2,ScrollX,ScrollY)/25
		ScrollX:+Cos(Angle)*Dist
		ScrollY:+Sin(Angle)*Dist
		
		If CurrentWire.Child=Null 
			Live=4
			TGameMap.Load()
			ScrollX=0
			ScrollY=0
			SetPosition(TGameMap.StartWire.Child)
			
		EndIf
	EndMethod
EndType
Type TCloud
	Global Clouds:TList=New TList
	Global CloudImg:TImage
	Field X:Float, Y:Float, Sz:Float=Rnd(.9,1.2)
	Method Update()
		X:+1
	EndMethod
	Method Render()
		SetAlpha .1
		SetColor 0,0,0
		DrawImage CloudImg, X-ScrollX*.8+4,Y-ScrollY*.8+8
		SetColor 255,255,255
		
		SetAlpha .8
		DrawImage CloudImg, X-ScrollX*.8,Y-ScrollY*.8
		
		
	EndMethod
	Method New()
		X=-ScreenWidth
		Y=Rand(0,TGameMap.MapHeight)
		Clouds.AddLast(Self)
	EndMethod
EndType
Type TSweet
	Global Img1:TImage, Img2:TImage, Img3:TImage
	Global List:TList=New TList
	Field X:Float, Y:Float, VX:Float, VY:Float
	Field W:TWire
	Field MaxDist:Float=Rand(80,270)
	Field Img:TImage
	Field Rot:Int=0
	Method Update()
		X:+VX
		Y:+VY
		If W And getdistance(X,Y,W.X2,W.Y2)>MaxDist
			VX=-VX
			VY=-VY
		EndIf
	EndMethod
	Method Render()
		SetRotation Rot
		DrawImage img, X-ScrollX,Y-ScrollY
		SetRotation 0
	EndMethod
	Method Create(W:TWire)
		If W
			Self.W=W
			Local A:Int=W.Angle
			If Rand(1,0) A:+90 Else A:-90
			A:+Rand(-5,5)
			Self.X=W.X2+Cos(A)*MAxDist
			Self.Y=W.Y2+Sin(A)*MaxDist
			Rot=A+90
			A=A+180
			Local Speed:Float=Rnd(.5,1.5)
			VX=Cos(A)*Speed
			VY=Sin(A)*Speed
			Select Rand(1,2)
				Case 1
					Img=Img1
				Case 2
					Img=Img2
			EndSelect
		Else
			Img=Img3
			X=Rand(0,TGameMap.MapWidth)
			Y=-ScreenHeight/2
			VX=0
			VY=4
		EndIf
		
	EndMethod
	Method New()
		List.addlast(Self)
	EndMethod
EndType
Type TParticle
	Global List:TList=New TList
	Global Star:TImage
	Field X:Float,Y:Float,VX:Float, VY:Float
	Field S:Float=1
	Method Update()
		X:+VX
		Y:+VY
		S:-.025
		If S<.1 List.Remove(Self)
	EndMethod
	Method Render()
		SetScale S,S
		SetAlpha S
		DrawImage Star,X-ScrollX,Y-ScrollY
		SetScale 1,1
		SetAlpha 1
	EndMethod
	Method New()
		List.AddLast(Self)
		VX=Rand(-2,2)*4
		VY=Rand(-2,2)*4
		For Local C:TPlayer=EachIn TCar.Cars
			X=C.X
			Y=C.Y
			Exit 
		Next
	EndMethod
EndType
Global ScrollX:Float, ScrollY:Float
Global ScreenWidth:Int=800, ScreenHeight:Int=600
SeedRnd MilliSecs()



Graphics ScreenWidth, ScreenHeight


SetClsColor 128,128,128
SetBlend ALPHABLEND
AutoMidHandle True
TCar.CarImg=LoadImage("gfx/car.png")
SetImageHandle TCar.CarImg, TCar.CarIMg.Width/2,TCar.CarImg.Height
TWire.WireImg=LoadImage("gfx/wire.png")
SetImageHandle TWire.WireImg,0,TWire.WireImg.Height/2
TWire.ZapfenImg=LoadImage("gfx/zapfen.png")
SetImageHandle(TWire.ZapfenImg,TWire.ZapfenImg.Width/2,0)
TCloud.CloudImg=LoadImage("gfx/cloud.png")
TSweet.Img1=LoadImage("gfx/cookie.png")
TSweet.Img2=LoadImage("gfx/sugar.png")
TSweet.Img3=LoadImage("gfx/zapfen2.png")
TPlayer.LiveIMg=LoadImage("gfx/heart.png")
TParticle.Star=LoadImage("gfx/star.png")

While Menu("Startmenue","Spielen","Beenden")
	MainGame()
	Reset()
Wend
Function Reset()
	TGameMap.StartWire=Null
	TGameMap.CurrentLevel=0
	tcar.Cars.Clear()
	TCloud.Clouds.Clear()
	TSweet.List.Clear()
	TParticle.List.Clear()
EndFunction
Function RenderGame()
	TGameMap.Render()
	For Local C:TCar=EachIn TCar.Cars
		C.Render()
	Next
	For Local S:TSweet=EachIn TSweet.List
		S.Render()
	Next		
	For Local P:TParticle=EachIn TParticle.List
		P.Render()
	Next
EndFunction
Function MainGame()
	Local TImer:TTimer=CreateTimer(60)
	TGameMap.Load()
	Local Player:TCar=New TPlayer
	Player.SetPosition(TGameMap.StartWire.Child.Child)
	Repeat
		Repeat
			If Rand(1,TGameMap.RandDel)=1
				New TSweet.Create(Null)
			EndIf
			For Local C:TCar=EachIn TCar.Cars
				C.Update()
			Next
			For Local S:TSweet=EachIn TSweet.List
				S.Update()
			Next
			For Local C:TCloud=EachIn TCloud.Clouds
				C.Update()
			Next
			For Local P:TParticle=EachIn TParticle.List
				P.Update()
			Next
			TGameMap.StartWire.Update()
			RenderGame()
			Local b:Int=Rand(1,100)=1 And (New TCloud Or True)
			'DrawText GetFPS(),10,10
			WaitTimer Timer
			Flip 0
			Cls
		Until KeyHit(KEY_ESCAPE) Or AppTerminate()
	Until Not Menu("Spielmenue","Weiter","Startmenue")
	FlushMouse
	FlushKeys
EndFunction

Global fps_frames:Int, fps_ms:Int, fps_anzeige:Int
Function GetFPS:Int()
	fps_frames = fps_frames+1
	If MilliSecs()-fps_ms >= 1000 Then
		fps_anzeige = fps_frames
		fps_frames   = 0
		fps_ms      = MilliSecs()
	EndIf
	Return fps_anzeige
End Function
Function GetAngle:Float(X1:Float, Y1:Float, X2:Float, Y2:Float)
	Return (450-ATan2(X1-X2,Y1-Y2)) Mod 360 
EndFunction
Function getdistance#(x1#,y1#,x2#,y2#)
	Return Sqr((x1-x2)*(x1-x2) + (y1-y2)*(y1-y2))
End Function
Function rectsoverlap:Int(X1:Int, Y1:Int, Breite1:Int, Hoehe1:Int, X2:Int, Y2:Int, Breite2:Int, Hoehe2:Int)
	If x1 <= (x2 + breite2) And y1 <= y2 + hoehe2 And (x1 + breite1) >= x2 And (y1 + hoehe1) >= y2  Return True
	Return False
End Function
Function Menu:Int(Text:String, Button1:String,Button2:String)
	Local TImer:TTimer=CreateTimer(60)
	Repeat
		RenderGame()
		DrawText Text,200,100
		If Button(Button1,GraphicsHeight()/2) Return 1
		If Button(Button2,GraphicsHeight()/1.5) Return 0
		SetAlpha 1
		SetColor 255,255,255
		WaitTimer Timer
		Flip 0
		Cls
	Until AppTerminate() Or KeyHit(KEY_ESCAPE)
	Return 1
EndFunction
Function Button:Int(Text:String, Y:Int)
	SetColor 255,255,0
	
	SetAlpha .4
	If RectsOverlap(GraphicsWidth()/2-TextWidth(Text)/2,Y-TextHeight("l")/2,TextWidth(Text),TextHeight("l"),MouseX(),MouseY(),1,1)
		SetAlpha 1
		If MouseDown(1)
			Return 1
		EndIf
	EndIf
	SetHandle TextWidth(Text)/2,TextHeight("l")/2
	DrawRect GraphicsWidth()/2,Y,TextWidth(Text),TextHeight("l")
	SetColor 0,0,255
	DrawText Text,GraphicsWidth()/2,Y
	Return 0
EndFunction
